﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Net;

public partial class _Default : System.Web.UI.Page
{
    public payment payment = new payment();
    public bankAccountData bankAccountData = new bankAccountData(); //toDo -
    public card card = new card();
    public order order = new order();
    public buyer buyer = new buyer();
    public owner owner = new owner();
    public address address = new address();
    public address baddress = new address();
    public orderDetail orderDetail1 = new orderDetail();
    public orderDetail orderDetail2 = new orderDetail();
    public privateData privateData1 = new privateData();
    public privateData privateData2 = new privateData();
    public privateData privateData3 = new privateData();
    public privateData[] privateDataList = new privateData[3];
    public authentication3DSecure authentication3DSecure = new authentication3DSecure();
    public authorization authorization = new authorization();
    public cardOut cardOut = new cardOut();
    public extendedCardType extendedCardType = new extendedCardType();
    public transaction transaction = new transaction();
    public result resultat;
    public string errorMessage = "";
    public string errorDetails = "";
    public string version;
    public addressOwner addressOwner = new addressOwner();
    public string media;
    public string contractNumber = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        try
        {
            //DirectPaymentAPI ws = new DirectPaymentAPI();

            DirectPaymentAPI ws = new DirectPaymentAPI();

            //ws.MyOutHeaderMethod();
            
            // PAYMENT
            payment.amount = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("paymentAmount"))).Text;
            payment.mode = ((DropDownList)(Page.PreviousPage.FindControl("doAuthorization").FindControl("paymentMode"))).Text;
            payment.action = ((DropDownList)(Page.PreviousPage.FindControl("doAuthorization").FindControl("paymentFunction"))).Text;
            payment.currency = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("paymentCurrency"))).Text;
            payment.contractNumber = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("paymentContractNumber"))).Text;
            payment.differedActionDate = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("paymentDifferedActionDate"))).Text; // Format : "dd/mm/yy"

            //bankAccountData
            //Only for ELV
            bankAccountData.accountNumber = payment.differedActionDate = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("accountNumber"))).Text;
            bankAccountData.bankCode = payment.differedActionDate = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("bankCode"))).Text;
            bankAccountData.countryCode = payment.differedActionDate = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("countryCode"))).Text;
            bankAccountData.key = payment.differedActionDate = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("key"))).Text;

            // ORDER
            order.@ref = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("orderRef"))).Text;
            order.origin = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("orderOrigin"))).Text;
            order.country = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("orderCountry"))).Text;
            order.taxes = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("orderTaxes"))).Text;



            order.currency = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("orderCurrency"))).Text;
            if (order.currency == "")
                order.currency = Resources.Resource.ORDER_CURRENCY;

            order.amount = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("orderAmount"))).Text;
            order.date = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("orderDate"))).Text; // format : "dd/mm/yyyy HH24:MM"

            // ORDER DETAILS
            orderDetail1.@ref = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("orderDetailRef1"))).Text;
            orderDetail1.price = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("orderDetailPrice1"))).Text;
            orderDetail1.quantity = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("orderDetailQuantity1"))).Text;
            orderDetail1.comment = ((HtmlTextArea)(Page.PreviousPage.FindControl("doAuthorization").FindControl("orderDetailComment1"))).Value;

            orderDetail1.category = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("orderDetailCategory1"))).Text;
            orderDetail1.brand = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("orderDetailBrand1"))).Text;
            orderDetail1.subcategory1 = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("orderDetailSubcategory11"))).Text;
            orderDetail1.subcategory2 = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("orderDetailSubcategory21"))).Text;
            orderDetail1.additionalData = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("orderDetailAdditionalData1"))).Text;
            orderDetail1.taxRate = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("orderDetailTaxRate1"))).Text;

            orderDetail2.@ref = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("orderDetailRef2"))).Text;
            orderDetail2.price = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("orderDetailPrice2"))).Text;
            orderDetail2.quantity = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("orderDetailQuantity2"))).Text;
            orderDetail2.comment = ((HtmlTextArea)(Page.PreviousPage.FindControl("doAuthorization").FindControl("orderDetailComment2"))).Value;

            orderDetail2.category = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("orderDetailCategory2"))).Text;
            orderDetail2.brand = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("orderDetailBrand2"))).Text;
            orderDetail2.subcategory1 = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("orderDetailSubcategory12"))).Text;
            orderDetail2.subcategory2 = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("orderDetailSubcategory22"))).Text;
            orderDetail2.additionalData = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("orderDetailAdditionalData2"))).Text;
            orderDetail2.taxRate = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("orderDetailTaxRate2"))).Text;

            if (orderDetail1.@ref.Length > 0 && orderDetail2.@ref.Length > 0)
            {
                order.details = new orderDetail[2];
                order.details.SetValue(orderDetail1, 0);
                order.details.SetValue(orderDetail2, 1);
            }
            else if (orderDetail1.@ref.Length > 0 && orderDetail2.@ref.Length == 0)
            {
                order.details = new orderDetail[1];
                order.details.SetValue(orderDetail1, 0);
            }
            else if (orderDetail2.@ref.Length > 0 && orderDetail1.@ref.Length == 0)
            {
                order.details = new orderDetail[1];
                order.details.SetValue(orderDetail2, 0);
            }

            string deliveryMode = ((DropDownList)(Page.PreviousPage.FindControl("doAuthorization").FindControl("deliveryTime"))).Text;
            string deliveryTime = ((DropDownList)(Page.PreviousPage.FindControl("doAuthorization").FindControl("deliveryMode"))).Text;

            order.deliveryMode = (deliveryMode == "none") ? "" : deliveryMode;
            order.deliveryTime = (deliveryTime == "none") ? "" : deliveryTime;

            order.deliveryExpectedDate = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("deliveryExpectedDate"))).Text;
            order.deliveryExpectedDelay = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("deliveryExpectedDelay"))).Text;

                        
            // ADDRESS (optional)            
            address.name = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("addressName"))).Text;
            address.street1 = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("addressStreet1"))).Text;
            address.street2 = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("addressStreet2"))).Text;
            address.cityName = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("addressCity"))).Text;
            address.zipCode = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("addressZipCode"))).Text;
            address.country = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("addressCountry"))).Text;
            address.phone = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("addressPhone"))).Text;

            // BILLING ADDRESS (optional)  
            baddress.name = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("baddressName"))).Text;
            baddress.street1 = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("baddressStreet1"))).Text;
            baddress.street2 = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("baddressStreet2"))).Text;
            baddress.cityName = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("baddressCity"))).Text;
            baddress.zipCode = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("baddressZipCode"))).Text;
            baddress.country = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("baddressCountry"))).Text;
            baddress.phone = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("baddressPhone"))).Text;

            // BUYER (optional - not applicable to doAuthorization)
            buyer.shippingAdress = address;
            buyer.billingAddress = baddress;
            buyer.walletId = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("buyerWalletId"))).Text;
            buyer.lastName = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("buyerLastName"))).Text;
            buyer.firstName = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("buyerFirstName"))).Text;
            buyer.email = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("buyerEmail"))).Text;
            buyer.accountCreateDate = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("buyerAccountCreateDate"))).Text; // format : "dd/mm/yy"
            buyer.accountAverageAmount = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("buyerAccountAverageAmount"))).Text;
            buyer.accountOrderCount = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("buyerAccountOrderCount"))).Text;

            buyer.walletDisplayed = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("buyerWalletDisplayed"))).Text;
            buyer.walletSecured = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("buyerWalletSecured"))).Text;
            buyer.walletCardInd = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("buyerWalletCardInd"))).Text;
            buyer.ip = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("buyerIp"))).Text;
            buyer.mobilePhone = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("buyerMobilePhone"))).Text;
            buyer.customerId = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("buyerCustomerId"))).Text;

            // PRIVATE DATA (optional)            
            privateData1.key = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("privateDataKey1"))).Text;
            privateData1.value = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("privateDataValue1"))).Text;
            privateData2.key = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("privateDataKey2"))).Text;
            privateData2.value = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("privateDataValue2"))).Text;
            privateData3.key = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("privateDataKey3"))).Text;
            privateData3.value = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("privateDataValue3"))).Text;

            privateDataList.SetValue(privateData1, 0);
            privateDataList.SetValue(privateData2, 1);
            privateDataList.SetValue(privateData3, 2);

            //MEDIA
            media = ((DropDownList)(Page.PreviousPage.FindControl("doAuthorization").FindControl("media"))).Text;

            if (media == "none") 
            { 
                media = ""; 
            }

            //owner
            //Only for AMEX


            owner.lastName = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("ownerLastName"))).Text;
            owner.firstName = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("ownerFirstName"))).Text;
            owner.issueCardDate = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("ownerIssueCardDate"))).Text;


            addressOwner.street = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("addressOwnerStreet"))).Text;
            addressOwner.cityName = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("addressOwnerCityName"))).Text;
            addressOwner.zipCode = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("addressOwnerZipCode"))).Text;
            addressOwner.country = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("addressOwnerCountry"))).Text;
            addressOwner.phone = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("addressOwnerPhone"))).Text;

            owner.billingAddress = addressOwner;

            // CARD INFO
            card.encryptionKeyId = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("encryptionKeyId"))).Text;
            card.encryptedData = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("encryptedData"))).Text;


            card.number = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("cardNumber"))).Text;
            card.type = ((DropDownList)(Page.PreviousPage.FindControl("doAuthorization").FindControl("cardType"))).Text;
            card.expirationDate = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("cardExpirationDate"))).Text;
            card.cvx = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("cardCrypto"))).Text;
            card.ownerBirthdayDate = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("cardOwnerBirthdayDate"))).Text;
            card.password = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("cardPassword"))).Text;

            card.token = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("token"))).Text;


            //CARD PRESENT
            if (((DropDownList)(Page.PreviousPage.FindControl("doAuthorization").FindControl("cardPresent"))).Text != "")
            {
                card.cardPresent = ((DropDownList)(Page.PreviousPage.FindControl("doAuthorization").FindControl("cardPresent"))).Text;
            }

            card.cardholder = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("cardHolderName"))).Text; ;
            
            // AUTHENTICATION 3D SECURE (optional)           
             authentication3DSecure.md = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("md"))).Text;
             authentication3DSecure.pares = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("pares"))).Text;
             authentication3DSecure.xid = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("xid"))).Text;
             authentication3DSecure.eci = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("eci"))).Text;
             authentication3DSecure.cavv = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("cavv"))).Text;
             authentication3DSecure.cavvAlgorithm = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("cavvAlgorithm"))).Text;
             authentication3DSecure.vadsResult = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("vadsResult"))).Text;
             authentication3DSecure.typeSecurisation = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("typeSecurisation"))).Text;

             //version
             //To have more options
             version = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("version"))).Text;
             
            //PROXY
            
            if (Resources.Resource.PROXY_HOST != "" && Resources.Resource.PROXY_PORT != "")
            {
                ws.Proxy = new System.Net.WebProxy(Resources.Resource.PROXY_HOST, Convert.ToInt32(Resources.Resource.PROXY_PORT));
                if (Resources.Resource.PROXY_USER != "" && Resources.Resource.PROXY_PASSWORD != "")
                {
                    ws.Proxy.Credentials = new NetworkCredential(Resources.Resource.PROXY_USER, Resources.Resource.PROXY_PASSWORD);
                }
            }
            


            if (Resources.Resource.PROD == "true")
            {
                ws.Url = Resources.Resource.ENDPOINT_DIRECT;
            }
            else if (Resources.Resource.PROD == "dev")
            {
                ws.Url = Resources.Resource.ENDPOINT_DEV_DIRECT;
                System.Net.ServicePointManager.CertificatePolicy = new TrustAllCertificatePolicy();
            }


            ws.Credentials = new System.Net.NetworkCredential(Resources.Resource.MERCHANT_ID, Resources.Resource.ACCESS_KEY);

            resultat = ws.doAuthorization(version, payment, bankAccountData, card, order, buyer, owner, ref privateDataList, 
                                            authentication3DSecure, media,
                                            out transaction, out authorization, out cardOut, out extendedCardType, out contractNumber);
        }
        catch (Exception exc)
        {
            errorMessage = exc.Message;
            errorDetails = exc.ToString();
        }
    }
}
