﻿using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

public partial class _Default : System.Web.UI.Page 
{
    public address address = new address();
    public privateData privateData1 = new privateData();
    public privateData privateData2 = new privateData();
    public privateData privateData3 = new privateData();
    public privateData[] privateDataList = new privateData[3];
    public authentication3DSecure authentication3DSecure = new authentication3DSecure();

      
    public card card = new card();
    public wallet wallet = new wallet();
    public buyer buyer = new buyer();
    public string comment;
    public string contractNumber;
    public result resultat;
    public string errorMessage = "";
    public string errorDetails = "";

    public string version = "";
    public owner owner = new owner();
    public cardOut cardOut = new cardOut();
    public extendedCardType extendedCard = new extendedCardType();
    public addressOwner addressOwner = new addressOwner();

    public string media = "";
    public string[] contractNumberWalletList = new string[10];
    public string cardDefault = "";
    public fraudResultDetails fraudResultDetails = new fraudResultDetails();


    protected void Page_Load(object sender, EventArgs e)
    {
        try
        {
            DirectPaymentAPI ws = new DirectPaymentAPI();

            version = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("version"))).Text;
            
            // CONTRACT NUMBER

            contractNumber = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("contractNumber"))).Text;

            // ADDRESS (optional)            
            address.name = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("addressName"))).Text;
            address.street1 = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("addressStreet1"))).Text;
            address.street2 = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("addressStreet2"))).Text;
            address.cityName = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("addressCity"))).Text;
            address.zipCode = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("addressZipCode"))).Text;
            address.country = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("addressCountry"))).Text;
            address.phone = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("addressPhone"))).Text;

            // CARD INFO
            card.number = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("cardNumber"))).Text;
            card.type = ((DropDownList)(Page.PreviousPage.FindControl("createWallet").FindControl("cardType"))).Text;
            card.expirationDate = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("cardExpirationDate"))).Text;
            card.cvx = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("cardCrypto"))).Text;
            card.ownerBirthdayDate = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("cardOwnerBirthdayDate"))).Text;
            card.password = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("cardPassword"))).Text;
            card.cardPresent = (((CheckBox)(Page.PreviousPage.FindControl("createWallet").FindControl("cardPresent"))).Checked ? "Y" : "N");
            card.cardholder = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("cardHolderName"))).Text;
            card.encryptionKeyId = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("encryptionKeyId"))).Text;
            card.encryptedData = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("encryptedData"))).Text;

            card.token = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("token"))).Text;

             

            // PRIVATE DATA (optional)            
            privateData1.key = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("privateDataKey1"))).Text;
            privateData1.value = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("privateDataValue1"))).Text;
            privateData2.key = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("privateDataKey2"))).Text;
            privateData2.value = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("privateDataValue2"))).Text;
            privateData3.key = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("privateDataKey3"))).Text;
            privateData3.value = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("privateDataValue3"))).Text;

            privateDataList.SetValue(privateData1, 0);
            privateDataList.SetValue(privateData2, 1);
            privateDataList.SetValue(privateData3, 2);

            // WALLET INFO
            wallet.walletId = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("walletId"))).Text;
            wallet.lastName = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("lastName"))).Text;
            wallet.firstName = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("firstName"))).Text;
            wallet.email = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("email"))).Text;
            
            wallet.shippingAddress = address;
            wallet.comment = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("comment"))).Text;


            wallet.@default = (((CheckBox)(Page.PreviousPage.FindControl("createWallet").FindControl("default"))).Checked ? "Y" : "N");
            
            wallet.card = card;

            

            buyer.customerId = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("customerId"))).Text;
            buyer.accountCreateDate = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("accountCreatedDate"))).Text;
            buyer.ip = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("ip"))).Text;
            buyer.mobilePhone = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("mobilePhone"))).Text;
            buyer.shippingAdress = address;
            buyer.billingAddress = address;
            
            
            // AUTHENTICATION 3D SECURE (optional)           
            authentication3DSecure.md = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("md"))).Text;
            authentication3DSecure.pares = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("pares"))).Text;
            authentication3DSecure.typeSecurisation = "SSL";

            //owner
            //Only for AMEX

            
            owner.lastName = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("ownerLastName"))).Text;
            owner.firstName = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("ownerFirstName"))).Text;
            owner.issueCardDate = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("ownerIssueCardDate"))).Text;



            addressOwner.street = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("addressOwnerStreet"))).Text;
            addressOwner.cityName = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("addressOwnerCityName"))).Text;
            addressOwner.zipCode = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("addressOwnerZipCode"))).Text;
            addressOwner.country = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("addressOwnerCountry"))).Text;
            addressOwner.phone = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("addressOwnerPhone"))).Text;

            //owner.billingAddress = addressOwner;
            
            string str_contractNumberWalletList = ((TextBox)(Page.PreviousPage.FindControl("createWallet").FindControl("contractNumberWalletList"))).Text;

            if(str_contractNumberWalletList.Contains(";")){
                string[] split = str_contractNumberWalletList.Split(new Char[] { ';' });
                contractNumberWalletList = split;
            }
            else if (str_contractNumberWalletList != "")
            {
                contractNumberWalletList.SetValue(str_contractNumberWalletList,0);
            }
            

            //MEDIA
            media = ((DropDownList)(Page.PreviousPage.FindControl("createWallet").FindControl("media"))).Text;

            if (media == "none")
            {
                media = "";
            }

            //PROXY
            if (Resources.Resource.PROXY_HOST != "" && Resources.Resource.PROXY_PORT != "")
            {
                ws.Proxy = new System.Net.WebProxy(Resources.Resource.PROXY_HOST, Convert.ToInt32(Resources.Resource.PROXY_PORT));
                if (Resources.Resource.PROXY_USER != "" && Resources.Resource.PROXY_PASSWORD != "")
                {
                    ws.Proxy.Credentials = new System.Net.NetworkCredential(Resources.Resource.PROXY_USER, Resources.Resource.PROXY_PASSWORD);
                }
            }

            if (Resources.Resource.PROD == "true")
            {
                ws.Url = Resources.Resource.ENDPOINT_DIRECT;
            }
            else if (Resources.Resource.PROD == "dev")
            {
                ws.Url = Resources.Resource.ENDPOINT_DEV_DIRECT;
                System.Net.ServicePointManager.CertificatePolicy = new TrustAllCertificatePolicy();
            }

            ws.Credentials = new System.Net.NetworkCredential(Resources.Resource.MERCHANT_ID, Resources.Resource.ACCESS_KEY);

            resultat = ws.createWallet(version, contractNumber, wallet, buyer, owner, privateDataList, authentication3DSecure, 
                                        media, ref contractNumberWalletList, 
                                        out cardOut, out extendedCard, out fraudResultDetails);
        }
        catch (Exception exc)
        {
            errorMessage = exc.Message;
            errorDetails = exc.ToString();
        }
    }
}
