﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class _Default : System.Web.UI.Page 
{
    public result resultat;
    public string token;
    public string redirectURL;
    public bool debug;
    public string contractNumber ;
    public string contractNumberList;
    public string updatePersonalDetails = "";
    public buyer buyer = new buyer();
    public address address = new address();
    public address baddress = new address();
    public owner owner = new owner();
    public privateData privateData1 = new privateData();
    public privateData privateData2 = new privateData();
    public privateData privateData3 = new privateData();
    public privateData[] privateDataList = new privateData[3];
    public string[] selectedContractList = new string[2];
    public string errorMessage = "";
    public string errorDetails = "";
    public addressOwner addressOwner = new addressOwner();

    public string version;
    public string[] contractNumberWalletList = new string[10];
    
    protected void Page_Load(object sender, EventArgs e)
    {
        try
        {
            WebPaymentAPI ws = new WebPaymentAPI();

            version = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("version"))).Text;
            contractNumber = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("paymentContractNumber"))).Text;
            contractNumberList = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("paymentContractNumberList"))).Text;

            string contractNumberWalletList_str = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("contractNumberWalletList"))).Text;

            if (contractNumberList.Contains(";"))
            {
                string[] split = contractNumberList.Split(new Char[] { ';' });
                selectedContractList = split;             
            }
            else
            {
                selectedContractList.SetValue(contractNumberList, 0);
            }

            if (contractNumberWalletList_str.Contains(";"))
            {
                string[] split = contractNumberWalletList_str.Split(new Char[] { ';' });
                contractNumberWalletList = split;
            }
            else
            {
                contractNumberWalletList.SetValue(contractNumberWalletList_str, 0);
            }

            updatePersonalDetails = (((CheckBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("updatePersonalDetails"))).Checked) ? "1" : "";
                        

            // ADDRESS (optional)            
            address.name = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("addressName"))).Text;
            address.street1 = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("addressStreet1"))).Text;
            address.street2 = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("addressStreet2"))).Text;
            address.cityName = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("addressCity"))).Text;
            address.zipCode = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("addressZipCode"))).Text;
            address.country = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("addressCountry"))).Text;
            address.phone = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("addressPhone"))).Text;

            // BILLING ADDRESS (optional)  
            baddress.name = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("baddressName"))).Text;
            baddress.street1 = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("baddressStreet1"))).Text;
            baddress.street2 = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("baddressStreet2"))).Text;
            baddress.cityName = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("baddressCity"))).Text;
            baddress.zipCode = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("baddressZipCode"))).Text;
            baddress.country = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("baddressCountry"))).Text;
            baddress.phone = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("baddressPhone"))).Text;
            
            // BUYER (optional)      
            buyer.shippingAdress = address;
            buyer.billingAddress = baddress;
            buyer.walletId = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("buyerWalletId"))).Text;
            buyer.lastName = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("buyerLastName"))).Text;
            buyer.firstName = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("buyerFirstName"))).Text;
            buyer.email = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("buyerEmail"))).Text;
            buyer.accountCreateDate = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("buyerAccountCreateDate"))).Text; // format : "dd/mm/yy"
            buyer.accountAverageAmount = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("buyerAverageAmount"))).Text;
            buyer.accountOrderCount = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("buyerOrderCount"))).Text;


            //owner
            //Only for AMEX


            owner.lastName = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("ownerLastName"))).Text;
            owner.firstName = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("ownerFirstName"))).Text;
            owner.issueCardDate = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("ownerIssueCardDate"))).Text;



            addressOwner.street = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("addressOwnerStreet"))).Text;
            addressOwner.cityName = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("addressOwnerCityName"))).Text;
            addressOwner.zipCode = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("addressOwnerZipCode"))).Text;
            addressOwner.country = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("addressOwnerCountry"))).Text;
            addressOwner.phone = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("addressOwnerPhone"))).Text;

            owner.billingAddress = addressOwner;

            // PRIVATE DATA (optional)            
            privateData1.key = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("privateDataKey1"))).Text;
            privateData1.value = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("privateDataValue1"))).Text;
            privateData2.key = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("privateDataKey2"))).Text;
            privateData2.value = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("privateDataValue2"))).Text;
            privateData3.key = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("privateDataKey3"))).Text;
            privateData3.value = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("privateDataValue3"))).Text;

            privateDataList.SetValue(privateData1, 0);
            privateDataList.SetValue(privateData2, 1);
            privateDataList.SetValue(privateData3, 2);

            // TRANSACTION OPTIONS            
            string securityMode = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("securityMode"))).Text;
            if (securityMode == "")
                securityMode = Resources.Resource.SECURITY_MODE;

            string notificationURL = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("notificationURL"))).Text;
            if (notificationURL == "")
                notificationURL = Resources.Resource.NOTIFICATION_URL;

            string returnURL = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("returnURL"))).Text;
            if (returnURL == "")
                returnURL = Resources.Resource.RETURN_URL;

            string cancelURL = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("cancelURL"))).Text;
            if (cancelURL == "")
                cancelURL = Resources.Resource.CANCEL_URL;

            string customPaymentPageCode = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("customPaymentPageCode"))).Text;
            if (customPaymentPageCode == "")
                customPaymentPageCode = Resources.Resource.CUSTOM_PAYMENT_PAGE_CODE;

            string customPaymentTemplateURL = ((TextBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("customPaymentTemplateURL"))).Text;
            if (customPaymentTemplateURL == "")
                customPaymentTemplateURL = Resources.Resource.CUSTOM_PAYMENT_TEMPLATE_URL;

            string languageCode = ((DropDownList)(Page.PreviousPage.FindControl("createWebWallet").FindControl("languageCode"))).Text;
            if (languageCode == "")
                languageCode = Resources.Resource.LANGUAGE_CODE;


            //PROXY
            if (Resources.Resource.PROXY_HOST != "" && Resources.Resource.PROXY_PORT != "")
            {
                ws.Proxy = new System.Net.WebProxy(Resources.Resource.PROXY_HOST, Convert.ToInt32(Resources.Resource.PROXY_PORT));
                if (Resources.Resource.PROXY_USER != "" && Resources.Resource.PROXY_PASSWORD != "")
                {
                    ws.Proxy.Credentials = new System.Net.NetworkCredential(Resources.Resource.PROXY_USER, Resources.Resource.PROXY_PASSWORD);
                }
            }

            if (Resources.Resource.PROD == "true")
            {
                ws.Url = Resources.Resource.ENDPOINT_WEB;
            }
            else if (Resources.Resource.PROD == "dev")
            {
                ws.Url = Resources.Resource.ENDPOINT_DEV_WEB;
                System.Net.ServicePointManager.CertificatePolicy = new TrustAllCertificatePolicy();
            }

            ws.Credentials = new System.Net.NetworkCredential(Resources.Resource.MERCHANT_ID, Resources.Resource.ACCESS_KEY);

            resultat = ws.createWebWallet(version, contractNumber, selectedContractList, updatePersonalDetails, buyer, 
                                            owner, languageCode, customPaymentPageCode, securityMode, returnURL, cancelURL, 
                                            notificationURL, privateDataList, customPaymentTemplateURL, contractNumberWalletList, 
                                            out token, out redirectURL);

            debug = ((CheckBox)(Page.PreviousPage.FindControl("createWebWallet").FindControl("debug"))).Checked;
        }
        catch (Exception exc)
        {
            errorMessage = exc.Message;
            errorDetails = exc.ToString();
        }            
    }
}