﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class _Default : System.Web.UI.Page 
{
    public result resultat;
    public string token;
    public string redirectURL;
    public bool debug;
    public string contractNumber = "";
    public string walletId = "";    
    public string updatePersonalDetails = "";
    public string updatePaymentDetails = "";
    public order order = new order();    
    public recurring recurring = new recurring();
    public orderDetail orderDetail1 = new orderDetail();
    public orderDetail orderDetail2 = new orderDetail();
    public privateData privateData1 = new privateData();
    public privateData privateData2 = new privateData();
    public privateData privateData3 = new privateData();
    public privateData[] privateDataList = new privateData[3];
    public string[] selectedCrontractList = new string[100];
    public string errorMessage = "";
    public string errorDetails = "";
    public string cardIndex = "";
    public string updateOwnerDetails = "";

    public string media;
    public string[] contractNumberWalletList = new string[10];

    public string version;

    public buyer buyer = new buyer();

    public address address = new address();
    public address baddress = new address();
    
    protected void Page_Load(object sender, EventArgs e)
    {
        try
        {
            WebPaymentAPI ws = new WebPaymentAPI();

            version = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("version"))).Text;

            contractNumber = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("paymentContractNumber"))).Text;

            if (contractNumber.Contains(";"))
            {
                string[] split = contractNumber.Split(new Char[] { ';'});
                selectedCrontractList = split;
                contractNumber = Resources.Resource.CONTRACT_NUMBER;                
            }
            else
            {
                selectedCrontractList.SetValue(contractNumber, 0);
            }

            walletId = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("walletId"))).Text;
            cardIndex = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("cardIndex"))).Text;

            updatePersonalDetails = (((CheckBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("updatePersonalDetails"))).Checked ? "1" : "0");
            updateOwnerDetails = (((CheckBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("updateOwnerDetails"))).Checked ? "1" : "0");
            updatePaymentDetails = (((CheckBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("updatePaymentDetails"))).Checked ? "1" : "0");
            
            // PRIVATE DATA (optional)            
            privateData1.key = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("privateDataKey1"))).Text;
            privateData1.value = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("privateDataValue1"))).Text;
            privateData2.key = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("privateDataKey2"))).Text;
            privateData2.value = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("privateDataValue2"))).Text;
            privateData3.key = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("privateDataKey3"))).Text;
            privateData3.value = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("privateDataValue3"))).Text;
            
            privateDataList.SetValue(privateData1,0);
            privateDataList.SetValue(privateData2,1);
            privateDataList.SetValue(privateData3,2);

            // SHIPPING ADDRESS (optional)            
            address.name = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("addressName"))).Text;
            address.street1 = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("addressStreet1"))).Text;
            address.street2 = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("addressStreet2"))).Text;
            address.cityName = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("addressCity"))).Text;
            address.zipCode = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("addressZipCode"))).Text;
            address.country = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("addressCountry"))).Text;
            address.phone = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("addressPhone"))).Text;

            address.county = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("addressCounty"))).Text;
            address.phoneType = ((DropDownList)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("addressPhoneType"))).Text;

            // BILLING ADDRESS (optional)  
            baddress.name = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("baddressName"))).Text;
            baddress.street1 = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("baddressStreet1"))).Text;
            baddress.street2 = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("baddressStreet2"))).Text;
            baddress.cityName = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("baddressCity"))).Text;
            baddress.zipCode = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("baddressZipCode"))).Text;
            baddress.country = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("baddressCountry"))).Text;
            baddress.phone = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("baddressPhone"))).Text;

            baddress.county = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("baddressCounty"))).Text;
            baddress.phoneType = ((DropDownList)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("baddressPhoneType"))).Text;

            // BUYER (optional) 
            buyer.lastName = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("buyerLastName"))).Text;
            buyer.firstName = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("buyerFirstName"))).Text;
            buyer.email = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("buyerEmail"))).Text;

            buyer.shippingAdress = address;
            buyer.billingAddress = baddress;

            buyer.accountCreateDate = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("buyerAccountCreateDate"))).Text; // format : "dd/mm/yy"
            buyer.accountAverageAmount = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("buyerAccountAverageAmount"))).Text;
            buyer.accountOrderCount = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("buyerAccountOrderCount"))).Text;
            buyer.walletId = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("buyerWalletId"))).Text;

            //4.42
            string legalStatus = ((DropDownList)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("buyerLegalStatus"))).Text;
            string legalDocument = ((DropDownList)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("buyerLegalDocument"))).Text;

            buyer.legalStatus = (legalStatus == "--") ? "" : legalStatus;
            buyer.legalDocument = (legalDocument == "--") ? "" : legalDocument;

            buyer.birthDate = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("buyerBirthDate"))).Text;
            buyer.fingerprintID = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("buyerFingerprintID"))).Text;


            string walletDisplayed = ((DropDownList)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("buyerWalletDisplayed"))).Text;

            buyer.walletDisplayed = (walletDisplayed == "--") ? "" : "none";

            string walletSecured = ((DropDownList)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("buyerWalletSecured"))).Text;

            buyer.walletSecured = (walletSecured == "--") ? "" : "CVV";

            buyer.walletCardInd = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("buyerWalletCardInd"))).Text;
            buyer.ip = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("buyerIp"))).Text;
            buyer.mobilePhone = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("buyerMobilePhone"))).Text;
            buyer.customerId = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("buyerCustomerId"))).Text;

            
            // TRANSACTION OPTIONS 
            string securityMode = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("securityMode"))).Text;
            if (securityMode == "")
                securityMode = Resources.Resource.SECURITY_MODE;

            string notificationURL = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("notificationURL"))).Text;
            if (notificationURL == "")
                notificationURL = Resources.Resource.NOTIFICATION_URL;

            string returnURL = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("returnURL"))).Text;
            if (returnURL == "")
                returnURL = Resources.Resource.RETURN_URL;

            string cancelURL = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("cancelURL"))).Text;
            if (cancelURL == "")
                cancelURL = Resources.Resource.CANCEL_URL;

            string customPaymentPageCode = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("customPaymentPageCode"))).Text;
            if (customPaymentPageCode == "")
                customPaymentPageCode = Resources.Resource.CUSTOM_PAYMENT_PAGE_CODE;

            string customPaymentTemplateURL = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("customPaymentTemplateURL"))).Text;
            if (customPaymentTemplateURL == "")
                customPaymentTemplateURL = Resources.Resource.CUSTOM_PAYMENT_TEMPLATE_URL;

            string languageCode = ((DropDownList)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("languageCode"))).Text;
            if (languageCode == "")
                languageCode = Resources.Resource.LANGUAGE_CODE;

            //MEDIA
            media = ((DropDownList)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("media"))).Text;

            if (media == "none")
            {
                media = "";
            }


            string str_contractNumberWalletList = ((TextBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("contractNumberWalletList"))).Text;

            if (str_contractNumberWalletList.Contains(";"))
            {
                string[] split = str_contractNumberWalletList.Split(new Char[] { ';' });
                contractNumberWalletList = split;
            }
            else if (str_contractNumberWalletList != "")
            {
                contractNumberWalletList[0] = str_contractNumberWalletList;
            }
            else
            {
                contractNumberWalletList = null;
            }


            //PROXY
            if (Resources.Resource.PROXY_HOST != "" && Resources.Resource.PROXY_PORT != "")
            {
                ws.Proxy = new System.Net.WebProxy(Resources.Resource.PROXY_HOST, Convert.ToInt32(Resources.Resource.PROXY_PORT));
                if (Resources.Resource.PROXY_USER != "" && Resources.Resource.PROXY_PASSWORD != "")
                {
                    ws.Proxy.Credentials = new System.Net.NetworkCredential(Resources.Resource.PROXY_USER, Resources.Resource.PROXY_PASSWORD);
                }
            }

            if (Resources.Resource.PROD == "true")
            {
                ws.Url = Resources.Resource.ENDPOINT_WEB;
            }
            else if (Resources.Resource.PROD == "dev")
            {
                ws.Url = Resources.Resource.ENDPOINT_DEV_WEB;
                System.Net.ServicePointManager.CertificatePolicy = new TrustAllCertificatePolicy();
            }

            ws.Credentials = new System.Net.NetworkCredential(Resources.Resource.MERCHANT_ID, Resources.Resource.ACCESS_KEY);

            resultat = ws.updateWebWallet(version, contractNumber, cardIndex, walletId, updatePersonalDetails, updateOwnerDetails, 
                                            updatePaymentDetails, buyer, languageCode, customPaymentPageCode, securityMode, 
                                            returnURL, cancelURL, notificationURL, privateDataList, customPaymentTemplateURL, 
                                            contractNumberWalletList,
                                            out token, out redirectURL);

            debug = ((CheckBox)(Page.PreviousPage.FindControl("updateWebWallet").FindControl("debug"))).Checked;
        }
        catch (Exception exc)
        {
            errorMessage = exc.Message;
            errorDetails = exc.ToString();
        }            
    }
}