<%@ Page Language="C#" AutoEventWireup="true" %>

<%@ PreviousPageType VirtualPath="~/index.aspx" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head id="Head1" runat="server">
    <title>Payline demo - GetToken Response</title>
    <link rel="stylesheet" type="text/css" media="screen" href="../css/reset.css" />
    <link rel="stylesheet" type="text/css" media="screen" href="../css/style.css" />
    <link rel="stylesheet" type="text/css" media="screen" href="../css/header.css" />
    <link rel="stylesheet" type="text/css" media="screen" href="../css/forms.css" />
    <script type="text/javascript" src="../scripts/mootools-1.11.js"></script>
    <script type="text/javascript" src="../scripts/demos.js"></script>
    <style type="text/css">
        ul, li
        {
            list-style-type: none;
        }
        ul
        {
            margin: 0 0 10px 0;
        }
        li
        {
            padding-left: 10px;
        }
        .object
        {
            color: #A6C835;
            font-size: 14px;
        }
    </style>
</head>
<body>
    <div id="header">
        <div id="header-inside">
            <div id="logo">
                <h1>
                    <a href="http://www.payline.com"><span>payline</span></a></h1>
                <p>
                    by experian</p>
            </div>
        </div>
    </div>
    <div id="wrapper">
        <div id="container">
            <div id="content" class="en">
                <!--a href="javascript:history.back()" class="goback">Back</a-->
                <br />
                <%
                    try
                    {
                        if (Request.Params["data"] != null)
                        {

                            string data = Request.Params["data"];
                            string actionCode = "110";
                            byte[] key = SDKPayline.Utils.Hash256(Resources.Resource.ACCESS_KEY);
                            string decrypt = SDKPayline.Utils.Decompress(SDKPayline.Utils.AESDecrypt(data, key));
                            

                            //Class1.ecritureUnFichier(" Donnees brutes " + data + "\n cle de decryptage " + Convert.ToBase64String(key) + "\n Decryptee " + decrypt);
                            
                            string[] res = decrypt.Split(new char[] { ';' });

                            Response.Write("<h2>Rsultat de la tokenisation de la carte</h2><br />");
                            
                            Response.Write("getToken Result : " + decrypt + "<BR />");
                            Response.Write("token : " + res[0] + "<BR />");
                            Response.Write("expirationDate : " + res[1] + "<BR />");
                            Response.Write("virtualCard : " + res[2] + "<BR />");
                            Response.Write("orderRef : " + res[3] + "<BR />");
                            Response.Write("cardType Ex : VISA : " + res[4] + "<BR />");
                            Response.Write("cardTypeIsCVD : " + res[5] + "<BR />");
                            Response.Write("cardCountry : " + res[6] + "<BR />");
                            Response.Write("productCode (ex: L for Electron) : " + res[7] + "<BR />");
                            Response.Write("bankCode : " + res[8] + "<BR />");

                            if (Request.Params["makeTransaction"] != null && Request.Params["makeTransaction"] == "true")
                            {
                                if (Request.Params["action"] != null) actionCode = Request.Params["action"];

                                  
                            
                            
                            DirectPaymentAPI ws = new DirectPaymentAPI();
                            //PROXY
                            if (Resources.Resource.PROXY_HOST != "" && Resources.Resource.PROXY_PORT != "")
                            {
                                ws.Proxy = new System.Net.WebProxy(Resources.Resource.PROXY_HOST, Convert.ToInt32(Resources.Resource.PROXY_PORT));
                                if (Resources.Resource.PROXY_USER != "" && Resources.Resource.PROXY_PASSWORD != "")
                                {
                                    ws.Proxy.Credentials = new System.Net.NetworkCredential(Resources.Resource.PROXY_USER, Resources.Resource.PROXY_PASSWORD);
                                }
                            }


                            if (Resources.Resource.PROD == "true")
                            {
                                ws.Url = Resources.Resource.ENDPOINT_DIRECT;
                            }
                            else if (Resources.Resource.PROD == "dev")
                            {
                                ws.Url = Resources.Resource.ENDPOINT_DEV_DIRECT;
                                System.Net.ServicePointManager.CertificatePolicy = new TrustAllCertificatePolicy();
                            }

                            ws.Credentials = new System.Net.NetworkCredential(Resources.Resource.MERCHANT_ID, Resources.Resource.ACCESS_KEY);
                            payment payment = new payment();

                            payment.contractNumber = Resources.Resource.CONTRACT_NUMBER;

                            payment.action = actionCode;
                            payment.amount = "100";
                            payment.currency = "978";
                            payment.mode = "CPT";


                            card card = new card();
                            card.token = res[0];
                            card.cvx = res[2];
                            card.expirationDate = res[1];
                            card.type = (res[4] == "unknown") ? "CB" : res[4];
                            order order = new order();
                            order.@ref = res[3];
                            order.amount = "100";
                            order.currency = "978";
                            order.deliveryMode = "1";
                            order.deliveryTime = "1";
                            order.date = DateTime.Now.ToString("dd/MM/yyyy HH:mm");

                            buyer buyer = new buyer();
                            buyer.email = "support@payline.com";
                            buyer.firstName = "Support";
                            buyer.lastName = "Payline";

                            authentication3DSecure authentication3DSecure = new authentication3DSecure();
                            authorization authorization = new authorization();
                            bankAccountData bankAccountData = new bankAccountData();
                            cardOut cardOut = new cardOut();
                            extendedCardType extendedCardType = new extendedCardType();
                            privateData[] privateDataList = new privateData[100];
                            transaction transaction = new transaction();
                            owner owner = new owner();
                            string media = "Internet";
                            string version = "5";
                            string contractNumber = "";
                            result resultat = ws.doAuthorization(version, payment, bankAccountData, card, order, buyer, owner, ref privateDataList,
                                                            authentication3DSecure, media,
                                                            out transaction, out authorization, out cardOut, out extendedCardType, out contractNumber);


                            Response.Write("<h2><br />Rsultat d'une transaction faite avec ce token</h2><br />");
                            
                            Response.Write(SDKPayline.Utils.objectDetails(resultat));
                            Response.Write(SDKPayline.Utils.objectDetails(transaction));
                            Response.Write(SDKPayline.Utils.objectDetails(payment));
                            Response.Write(SDKPayline.Utils.objectDetails(order));
                            Response.Write(SDKPayline.Utils.objectDetails(buyer));
                        }

                        }
                        else if (Request.Params["errorCode"] != null)
                        {
                            string errorCode = Request.Params["errorCode"];

                            if (errorCode == "09101")
                            {
                                Response.Write("Accs non autoris (code existant) : " + errorCode + "<BR />");
                            }
                            else if (errorCode == "09102")
                            {
                                Response.Write("Compte commerant bloqu ou dsactiv (code existant) : " + errorCode + "<BR />");
                            }
                            else if (errorCode == "02703")
                            {
                                Response.Write("Action non autorise (code existant) : " + errorCode + "<BR />");
                            }
                            else if (errorCode == "02303")
                            {
                                Response.Write("Numro de contrat invalide (code existant) : " + errorCode + "<BR />");
                            }
                            else if (errorCode == "02623")
                            {
                                Response.Write("Nombre dessai maximal atteint : " + errorCode + "<BR />");
                            }
                            else if (errorCode == "02625")
                            {
                                Response.Write("Format du numro de carte incorrect : " + errorCode + "<BR />");
                            }
                            else if (errorCode == "02626")
                            {
                                Response.Write("Format de la date dexpiration incorrect ou date dexpiration non fournie : " + errorCode + "<BR />");
                            }
                            else if (errorCode == "02624")
                            {
                                Response.Write("Carte prime : " + errorCode + "<BR />");
                            }
                            else if (errorCode == "02627")
                            {
                                Response.Write("Format du CVV incorrect ou CVV non fourni : " + errorCode + "<BR />");
                            }
                            else if (errorCode == "02628")
                            {
                                Response.Write("Format de lURL de retour incorrect : " + errorCode + "<BR />");
                            }
                            else
                            {
                                Response.Write("Code erreur retourn : " + errorCode + "<BR />");
                            }

                        }

                    }
                    catch (Exception Exc)
                    {
                        Response.Write(Exc.Message);
                    }
                    
                %>
            </div>
        </div>
    </div>
    <div id="footer">
        <div id="footer-inside">
            <a href="http://www.experian.fr/" class="copy"></a>
            <p>
                copyright &copy;2012 <a href="http://www.monext.fr/">Monext</a></p>
        </div>
    </div>
</body>
</html>
