﻿<%@ Control Language="C#" AutoEventWireup="true" CodeFile="doReAuthorizationForm.ascx.cs" Inherits="web_WebUserControl" %>



    <form id="form1" runat="server" method="post" class="payline-form">

        <fieldset>
            <h4>WSDL's Version</h4>
            <div class="row">
                <label for="version">Version</label>
                <asp:TextBox runat="server" Id="version" Text="4" />
            </div>
        </fieldset>

        <fieldset>
            <h4>Transaction Id</h4>
            <div class="row">
                <label for="transactionId">Transaction id</label>
                <asp:TextBox runat="server" Id="transactionId" Text="" />
            </div>
        </fieldset>

        <fieldset>
            <h4>Payment</h4>
            <div class="row">
                <label for="paymentAmount">Payment amount</label>
                <asp:TextBox runat="server" Id="paymentAmount" Text="33300" />
            </div>
            <div class="row">
                <label for="paymentMode">Payment mode</label>
                <asp:DropDownList ID="paymentMode" runat="server">
                    <asp:ListItem value="CPT">CPT</asp:ListItem>
                    <asp:ListItem value="DIF">DIF</asp:ListItem>                
                </asp:DropDownList>                
            </div>

            <div class="row">
                <label for="paymentFunction">Payment function</label>
                <asp:DropDownList ID="paymentFunction" runat="server">
                    <asp:ListItem value="100">Autor</asp:ListItem>
                    <asp:ListItem value="101">Autor+Capture</asp:ListItem>                
                </asp:DropDownList>                
            </div>
            <div class="row">
                <label for="paymentCurrency">Payment currency</label>
                <asp:TextBox runat="server" Id="paymentCurrency" Text="978" />
            </div>
            <div class="row">
                <label for="paymentContractNumber">Contract number</label>
                <asp:TextBox runat="server" Id="paymentContractNumber" Text="1234567" />
            </div>
            <div class="row">
                <label for="paymentDifferedActionDate">Differed action date</label>
                <asp:TextBox runat="server" Id="paymentDifferedActionDate" Text="" />
            </div>
        </fieldset>

        <fieldset>
        <h4>Informations about order</h4>
        <div class="row">
            <label for="orderRef">Order reference</label>
            <asp:TextBox runat="server" Id="orderRef" Text="1234" />
            <span class="help">(required)</span>
        </div>
        <div class="row">
            <label for="orderOrigin">Order origin</label>
            <asp:TextBox runat="server" Id="orderOrigin" Text="1" />
        </div>
        <div class="row">
            <label for="orderCountry">Order country</label>
            <asp:TextBox runat="server" Id="orderCountry" Text="FR" />
        </div>
        <div class="row">
            <label for="orderTaxes">Order taxes</label>
            <asp:TextBox runat="server" Id="orderTaxes" Text="0" />
        </div>
         <div class="row">
            <label for="orderCurrency">Order currency</label>            
            <asp:TextBox runat="server" Id="orderCurrency" Text="978" />
            <span class="help">(required)</span>
        </div>
        <div class="row">
            <label for="orderAmount">Order amount</label>
            <asp:TextBox runat="server" Id="orderAmount" Text="30000" />
            <span class="help">(required)</span>
        </div>        
        <div class="row">
            <label for="orderDate">Order date</label>
            <asp:TextBox runat="server" Id="orderDate" Text="12/05/2007 12:36" />
            <span class="help">(required format : "dd/mm/yyyy HH24:MM")</span>
        </div>

        <div class="row">
            <label for="deliveryTime">Delivery time</label>
            <asp:DropDownList ID="deliveryTime" runat="server" Height="16px">
                <asp:ListItem value="1">Standard</asp:ListItem>
                <asp:ListItem value="2">Express</asp:ListItem>
                <asp:ListItem value="none">none</asp:ListItem>
            </asp:DropDownList>
            <span class="help">(Only when the WSDL's version >= 4)</span>
        </div>

        <div class="row">
            <label for="deliveryMode">Delivery mode</label>
            <asp:DropDownList ID="deliveryMode" runat="server" Height="16px">
                <asp:ListItem value="1">Retrait chez le marchand</asp:ListItem>
                <asp:ListItem value="2">Point retrait</asp:ListItem>
                <asp:ListItem value="3">Retrait dans un aéroport, une gare ou une agence de voyage</asp:ListItem>
                <asp:ListItem value="4">Transporteur privé</asp:ListItem>
                <asp:ListItem value="5">Emission d’un billet électronique, téléchargements</asp:ListItem>
                <asp:ListItem value="none">none</asp:ListItem>
            </asp:DropDownList>
            <span class="help">(Only when the WSDL's version >= 4)</span>
        </div>

        <div class="row">
            <label for="deliveryExpectedDate">Order delivery Expected Date</label>
            <asp:TextBox runat="server" Id="deliveryExpectedDate" Text="" />
        </div>
        <div class="row">
            <label for="deliveryExpectedDelay">Order delivery Expected Delay</label>
            <asp:TextBox runat="server" Id="deliveryExpectedDelay" Text="" />
        </div>
	</fieldset>
	<fieldset>
        <h4>Order details</h4>
        <div class="row">
            <label for="orderDetailRef1">Item reference 1</label>
            <asp:TextBox runat="server" Id="orderDetailRef1" Text="reference1" />
        </div>
        <div class="row">
            <label for="orderDetailPrice1">Item price 1</label>
            <asp:TextBox runat="server" Id="orderDetailPrice1" Text="1" />
        </div>
        <div class="row">
            <label for="orderDetailQuantity1">Item quantity 1</label>
            <asp:TextBox runat="server" Id="orderDetailQuantity1" Text="1" />
        </div>
        <div class="row">
            <label for="orderDetailComment1">Item comment 1</label>
            <textarea rows="2" cols="20" id="orderDetailComment1" runat="server">Comment for item 1</textarea>
        </div>

        
        <div class="row">
            <label for="orderDetailCategory1">Category 1</label>
            <asp:TextBox runat="server" Id="orderDetailCategory1" Text="" />
        </div>
        <div class="row">
            <label for="orderDetailBrand1">Brand 1</label>
            <asp:TextBox runat="server" Id="orderDetailBrand1" Text="" />
        </div>
        <div class="row">
            <label for="orderDetailSubcategory11">Subcategory1 1</label>
            <asp:TextBox runat="server" Id="orderDetailSubcategory11" Text="" />
        </div>
        <div class="row">
            <label for="orderDetailSubcategory21">Subcategory2 1</label>
            <asp:TextBox runat="server" Id="orderDetailSubcategory21" Text="" />
        </div>
        <div class="row">
            <label for="orderDetailAdditionalData1">Additional Data 1</label>
            <asp:TextBox runat="server" Id="orderDetailAdditionalData1" Text="" />
        </div>
        <div class="row">
            <label for="orderDetailTaxRate1">Tax Rate 1</label>
            <asp:TextBox runat="server" Id="orderDetailTaxRate1" Text="" />
        </div>


        <hr/>
        <div class="row">
            <label for="orderDetailRef2">Item reference 2</label>
            <asp:TextBox runat="server" Id="orderDetailRef2" Text="reference2" />
        </div>
        <div class="row">
            <label for="orderDetailPrice2">Item price 2</label>
            <asp:TextBox runat="server" Id="orderDetailPrice2" Text="1" />
        </div>
        <div class="row">
            <label for="orderDetailQuantity2">Item quantity 2</label>
            <asp:TextBox runat="server" Id="orderDetailQuantity2" Text="1" />
        </div>
        <div class="row">
            <label for="orderDetailComment2">Item comment 2</label>
            <textarea rows="2" cols="20" name="orderDetailComment2" id="orderDetailComment2" runat="server">Comment for item 2</textarea>
        </div>


        <div class="row">
            <label for="orderDetailCategory2">Category 2</label>
            <asp:TextBox runat="server" Id="orderDetailCategory2" Text="" />
        </div>
        <div class="row">
            <label for="orderDetailBrand2">Brand 2</label>
            <asp:TextBox runat="server" Id="orderDetailBrand2" Text="" />
        </div>
        <div class="row">
            <label for="orderDetailSubcategory12">Subcategory1 2</label>
            <asp:TextBox runat="server" Id="orderDetailSubcategory12" Text="" />
        </div>
        <div class="row">
            <label for="orderDetailSubcategory22">Subcategory2 2</label>
            <asp:TextBox runat="server" Id="orderDetailSubcategory22" Text="" />
        </div>
        <div class="row">
            <label for="orderDetailAdditionalData2">Additional Data 2</label>
            <asp:TextBox runat="server" Id="orderDetailAdditionalData2" Text="" />
        </div>
        <div class="row">
            <label for="orderDetailTaxRate2">Tax Rate 2</label>
            <asp:TextBox runat="server" Id="orderDetailTaxRate2" Text="" />
        </div>


    </fieldset>   

    <fieldset>
        <h4>Private datas</h4>
        <div class="row">
            <label for="privateDataKey1">Private data key 1</label>
            <asp:TextBox runat="server" Id="privateDataKey1" Text="key 1" />
        </div>
        <div class="row">
            <label for="privateDataValue1">Private data value 1</label>
            <asp:TextBox runat="server" Id="privateDataValue1" Text="1" />
        </div>  
        <hr/>
        <div class="row">
            <label for="privateDataKey2">Private data key 2</label>
            <asp:TextBox runat="server" Id="privateDataKey2" Text="key 2" />
        </div>   
        <div class="row">
            <label for="privateDataValue2">Private data value 2</label>
            <asp:TextBox runat="server" Id="privateDataValue2" Text="value 2" />
        </div>
        <hr/>
        <div class="row">
            <label for="privateDataKey3">Private data key 3</label>
            <asp:TextBox runat="server" Id="privateDataKey3" Text="key 3" />
        </div>   
        <div class="row">
            <label for="privateDataValue3">Private data value 2</label>
            <asp:TextBox runat="server" Id="privateDataValue3" Text="value 3" />
        </div>     
	</fieldset>
     <fieldset>
        <h4>Media</h4>
        <div class="row">
            <label for="media">Media</label>
            <asp:DropDownList ID="media" runat="server">
                <asp:ListItem value="none">none</asp:ListItem>
                <asp:ListItem value="Internet">Internet</asp:ListItem>
                <asp:ListItem value="Mobile">Mobile</asp:ListItem>
                <asp:ListItem value="Tablet">Tablet</asp:ListItem>
                <asp:ListItem value="TV">TV</asp:ListItem>
                <asp:ListItem value="Console">Console</asp:ListItem>
                <asp:ListItem value="Undefined">Undefined</asp:ListItem>
            </asp:DropDownList>
        </div>
    </fieldset>

    <asp:Button ID="Button1" PostBackUrl="~/direct/doReAuthorization.aspx" CssClass="submit" runat="server" Text="reAuthorization" />
    </form>

