﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class _Default : System.Web.UI.Page 
{
    public payment payment = new payment();
    public order order = new order();
    public orderDetail orderDetail1 = new orderDetail();
    public orderDetail orderDetail2 = new orderDetail();
    public privateData privateData1 = new privateData();
    public privateData privateData2 = new privateData();
    public privateData privateData3 = new privateData();
    public privateData[] privateDataList = new privateData[3];
    public transaction transaction;
    public authorization authorization;
    public string walletId;
    public result resultat;
    public string errorMessage = "";
    public string errorDetails = "";

    public string cardInd = "";

    public string version;
    public string media;
    public string cvx = "";
   
    public authentication3DSecure authentication3DSecure = new authentication3DSecure();
    public buyer buyer = new buyer();

    public address address = new address();
    public address baddress = new address();

    protected void Page_Load(object sender, EventArgs e)
    {
        try
        {
            DirectPaymentAPI ws = new DirectPaymentAPI();

            //WSDL VERSION
            version = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("version"))).Text;

            //MEDIA
            media = ((DropDownList)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("media"))).Text;

            if (media == "none")
            {
                media = "";
            }
            
            walletId = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("walletId"))).Text;

            cardInd = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("cardIndex"))).Text;
            cvx = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("cvx"))).Text;

            // PAYMENT
            payment.amount = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("paymentAmount"))).Text;
            payment.mode = ((DropDownList)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("paymentMode"))).Text;
            payment.action = ((DropDownList)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("paymentFonction"))).Text;
            payment.currency = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("paymentCurrency"))).Text;
            payment.contractNumber = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("paymentContractNumber"))).Text;
            payment.differedActionDate = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("paymentDifferedActionDate"))).Text; // Format : "dd/mm/yy"

            // ORDER
            order.@ref = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("orderRef"))).Text;
            order.origin = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("orderOrigin"))).Text;
            order.country = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("orderCountry"))).Text;
            order.taxes = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("orderTaxes"))).Text;



            order.currency = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("orderCurrency"))).Text;
            if (order.currency == "")
                order.currency = Resources.Resource.ORDER_CURRENCY;

            order.amount = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("orderAmount"))).Text;
            order.date = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("orderDate"))).Text; // format : "dd/mm/yyyy HH24:MM"

            // ORDER DETAILS
            orderDetail1.@ref = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("orderDetailRef1"))).Text;
            orderDetail1.price = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("orderDetailPrice1"))).Text;
            orderDetail1.quantity = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("orderDetailQuantity1"))).Text;
            orderDetail1.comment = ((HtmlTextArea)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("orderDetailComment1"))).Value;

            orderDetail1.category = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("orderDetailCategory1"))).Text;
            orderDetail1.brand = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("orderDetailBrand1"))).Text;
            orderDetail1.subcategory1 = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("orderDetailSubcategory11"))).Text;
            orderDetail1.subcategory2 = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("orderDetailSubcategory21"))).Text;
            orderDetail1.additionalData = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("orderDetailAdditionalData1"))).Text;
            orderDetail1.taxRate = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("orderDetailTaxRate1"))).Text;

            orderDetail2.@ref = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("orderDetailRef2"))).Text;
            orderDetail2.price = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("orderDetailPrice2"))).Text;
            orderDetail2.quantity = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("orderDetailQuantity2"))).Text;
            orderDetail2.comment = ((HtmlTextArea)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("orderDetailComment2"))).Value;

            orderDetail2.category = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("orderDetailCategory2"))).Text;
            orderDetail2.brand = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("orderDetailBrand2"))).Text;
            orderDetail2.subcategory1 = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("orderDetailSubcategory12"))).Text;
            orderDetail2.subcategory2 = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("orderDetailSubcategory22"))).Text;
            orderDetail2.additionalData = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("orderDetailAdditionalData2"))).Text;
            orderDetail2.taxRate = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("orderDetailTaxRate2"))).Text;

            if (orderDetail1.@ref.Length > 0 && orderDetail2.@ref.Length > 0)
            {
                order.details = new orderDetail[2];
                order.details.SetValue(orderDetail1, 0);
                order.details.SetValue(orderDetail2, 1);
            }
            else if (orderDetail1.@ref.Length > 0 && orderDetail2.@ref.Length == 0)
            {
                order.details = new orderDetail[1];
                order.details.SetValue(orderDetail1, 0);
            }
            else if (orderDetail2.@ref.Length > 0 && orderDetail1.@ref.Length == 0)
            {
                order.details = new orderDetail[1];
                order.details.SetValue(orderDetail2, 0);
            }

            string deliveryMode = ((DropDownList)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("deliveryTime"))).Text;
            string deliveryTime = ((DropDownList)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("deliveryMode"))).Text;

            order.deliveryMode = (deliveryMode == "none") ? "" : deliveryMode;
            order.deliveryTime = (deliveryTime == "none") ? "" : deliveryTime;

            order.deliveryExpectedDate = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("deliveryExpectedDate"))).Text;
            order.deliveryExpectedDelay = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("deliveryExpectedDelay"))).Text;

                                    
            // PRIVATE DATA (optional)            
            privateData1.key = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("privateDataKey1"))).Text;
            privateData1.value = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("privateDataValue1"))).Text;
            privateData2.key = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("privateDataKey2"))).Text;
            privateData2.value = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("privateDataValue2"))).Text;
            privateData3.key = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("privateDataKey3"))).Text;
            privateData3.value = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("privateDataValue3"))).Text;

            privateDataList.SetValue(privateData1, 0);
            privateDataList.SetValue(privateData2, 1);
            privateDataList.SetValue(privateData3, 2);


            // AUTHENTICATION 3D SECURE (optional)           
            authentication3DSecure.md = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("md"))).Text;
            authentication3DSecure.pares = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("pares"))).Text;
            authentication3DSecure.xid = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("xid"))).Text;
            authentication3DSecure.eci = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("eci"))).Text;
            authentication3DSecure.cavv = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("cavv"))).Text;
            authentication3DSecure.cavvAlgorithm = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("cavvAlgorithm"))).Text;
            authentication3DSecure.vadsResult = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("vadsResult"))).Text;
            authentication3DSecure.typeSecurisation = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("typeSecurisation"))).Text;


            // ADDRESS (optional)            
            address.name = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("addressName"))).Text;
            address.street1 = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("addressStreet1"))).Text;
            address.street2 = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("addressStreet2"))).Text;
            address.cityName = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("addressCity"))).Text;
            address.zipCode = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("addressZipCode"))).Text;
            address.country = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("addressCountry"))).Text;
            address.phone = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("addressPhone"))).Text;

            // BILLING ADDRESS (optional)  
            baddress.name = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("baddressName"))).Text;
            baddress.street1 = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("baddressStreet1"))).Text;
            baddress.street2 = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("baddressStreet2"))).Text;
            baddress.cityName = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("baddressCity"))).Text;
            baddress.zipCode = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("baddressZipCode"))).Text;
            baddress.country = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("baddressCountry"))).Text;
            baddress.phone = ((TextBox)(Page.PreviousPage.FindControl("doAuthorization").FindControl("baddressPhone"))).Text;



            // BUYER
            buyer.shippingAdress = address;
            buyer.billingAddress = baddress;
            buyer.walletId = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("buyerWalletId"))).Text;
            buyer.lastName = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("buyerLastName"))).Text;
            buyer.firstName = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("buyerFirstName"))).Text;
            buyer.email = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("buyerEmail"))).Text;
            buyer.accountCreateDate = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("buyerAccountCreateDate"))).Text; // format : "dd/mm/yy"
            buyer.accountAverageAmount = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("buyerAccountAverageAmount"))).Text;
            buyer.accountOrderCount = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("buyerAccountOrderCount"))).Text;

            buyer.walletDisplayed = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("buyerWalletDisplayed"))).Text;
            buyer.walletSecured = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("buyerWalletSecured"))).Text;
            buyer.walletCardInd = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("buyerWalletCardInd"))).Text;
            buyer.ip = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("buyerIp"))).Text;
            buyer.mobilePhone = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("buyerMobilePhone"))).Text;
            buyer.customerId = ((TextBox)(Page.PreviousPage.FindControl("doImmediateWalletPayment").FindControl("buyerCustomerId"))).Text;



            //PROXY
            if (Resources.Resource.PROXY_HOST != "" && Resources.Resource.PROXY_PORT != "")
            {
                ws.Proxy = new System.Net.WebProxy(Resources.Resource.PROXY_HOST, Convert.ToInt32(Resources.Resource.PROXY_PORT));
                if (Resources.Resource.PROXY_USER != "" && Resources.Resource.PROXY_PASSWORD != "")
                {
                    ws.Proxy.Credentials = new System.Net.NetworkCredential(Resources.Resource.PROXY_USER, Resources.Resource.PROXY_PASSWORD);
                }
            }

            if (Resources.Resource.PROD == "true")
            {
                ws.Url = Resources.Resource.ENDPOINT_DIRECT;
            }
            else if (Resources.Resource.PROD == "dev")
            {
                ws.Url = Resources.Resource.ENDPOINT_DEV_DIRECT;
                System.Net.ServicePointManager.CertificatePolicy = new TrustAllCertificatePolicy();
            }

            ws.Credentials = new System.Net.NetworkCredential(Resources.Resource.MERCHANT_ID, Resources.Resource.ACCESS_KEY);

            resultat = ws.doImmediateWalletPayment(version, payment, order, buyer, walletId, cardInd, cvx, privateDataList, media,
                                                   authentication3DSecure, out transaction, out authorization);

        }
        catch (Exception exc)
        {
            errorMessage = exc.Message;
            errorDetails = exc.ToString();
        }       
    }
}
