﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class _Default : System.Web.UI.Page 
{
    public address address = new address();
    public address baddress = new address();
    public address walletAddress = new address();
    public privateData privateData1 = new privateData();
    public privateData privateData2 = new privateData();
    public privateData privateData3 = new privateData();
    public privateData[] privateDataList = new privateData[3];
    public authentication3DSecure authentication3DSecure = new authentication3DSecure();
    public card card = new card();
    public wallet wallet = new wallet();
    public string contractNumber;
    public result resultat;
    public string errorMessage = "";
    public string errorDetails = "";

    public extendedCardType extendedCard = new extendedCardType();
    public owner owner = new owner();
    public cardOut cardOut = new cardOut();
    public string version;
    public string cardIndex;
    public addressOwner addressOwner = new addressOwner();
    public string media;
    public string[] contractNumberWalletList = new string[10];
    public buyer buyer = new buyer();

    protected void Page_Load(object sender, EventArgs e)
    {
        try
        {
            DirectPaymentAPI ws = new DirectPaymentAPI();

            version = contractNumber = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("version"))).Text;
            
            // CONTRACT NUMBER
            contractNumber = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("contractNumber"))).Text;

            string contractNumberWalletList_str = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("contractNumberWalletList"))).Text;

            if (contractNumberWalletList_str.Contains(";"))
            {
                string[] split = contractNumberWalletList_str.Split(new Char[] { ';' });
                contractNumberWalletList = split;
            }
            else
            {
                contractNumberWalletList.SetValue(contractNumberWalletList_str, 0);
            }

            cardIndex = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("buyerWalletCardInd"))).Text;
   
            // ADDRESS (optional)            
            walletAddress.name = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("addressName"))).Text;
            walletAddress.street1 = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("addressStreet1"))).Text;
            walletAddress.street2 = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("addressStreet2"))).Text;
            walletAddress.cityName = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("addressCity"))).Text;
            walletAddress.zipCode = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("addressZipCode"))).Text;
            walletAddress.country = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("addressCountry"))).Text;
            walletAddress.phone = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("addressPhone"))).Text;
            
            // CARD INFO
            card.number = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("cardNumber"))).Text;
            card.type = ((DropDownList)(Page.PreviousPage.FindControl("updateWallet").FindControl("cardType"))).Text;
            card.expirationDate = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("cardExpirationDate"))).Text;
            card.cvx = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("cardCrypto"))).Text;
            card.ownerBirthdayDate = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("cardOwnerBirthdayDate"))).Text;
            card.password = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("cardPassword"))).Text;
            
            // PRIVATE DATA (optional)            
            privateData1.key = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("privateDataKey1"))).Text;
            privateData1.value = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("privateDataValue1"))).Text;
            privateData2.key = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("privateDataKey2"))).Text;
            privateData2.value = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("privateDataValue2"))).Text;
            privateData3.key = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("privateDataKey3"))).Text;
            privateData3.value = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("privateDataValue3"))).Text;

            privateDataList.SetValue(privateData1, 0);
            privateDataList.SetValue(privateData2, 1);
            privateDataList.SetValue(privateData3, 2);

            // WALLET INFO
            wallet.walletId = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("walletId"))).Text;
            wallet.lastName = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("lastName"))).Text;
            wallet.firstName = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("firstName"))).Text;
            wallet.email = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("email"))).Text;
            wallet.@default = (((CheckBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("default"))).Checked ? "Y" : "N");
            wallet.card = card;
            wallet.shippingAddress = walletAddress;
            wallet.comment = ((HtmlTextArea)(Page.PreviousPage.FindControl("updateWallet").FindControl("comment"))).Value;


            //owner
            //Only for AMEX


            owner.lastName = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("ownerLastName"))).Text;
            owner.firstName = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("ownerFirstName"))).Text;
            owner.issueCardDate = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("ownerIssueCardDate"))).Text;

            addressOwner.street = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("addressOwnerStreet"))).Text;
            addressOwner.cityName = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("addressOwnerCityName"))).Text;
            addressOwner.zipCode = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("addressOwnerZipCode"))).Text;
            addressOwner.country = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("addressOwnerCountry"))).Text;
            addressOwner.phone = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("addressOwnerPhone"))).Text;

            owner.billingAddress = addressOwner;


            // AUTHENTICATION 3D SECURE (optional)           
            authentication3DSecure.md = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("md"))).Text;
            authentication3DSecure.pares = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("pares"))).Text;

            //MEDIA
            media = ((DropDownList)(Page.PreviousPage.FindControl("updateWallet").FindControl("media"))).Text;

            if (media == "none")
            {
                media = "";
            }


            // SHIPPING ADDRESS (optional)            
            address.name = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("addressName"))).Text;
            address.street1 = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("addressStreet1"))).Text;
            address.street2 = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("addressStreet2"))).Text;
            address.cityName = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("addressCity"))).Text;
            address.zipCode = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("addressZipCode"))).Text;
            address.country = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("addressCountry"))).Text;
            address.phone = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("addressPhone"))).Text;

            address.county = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("addressCounty"))).Text;
            address.phoneType = ((DropDownList)(Page.PreviousPage.FindControl("updateWallet").FindControl("addressPhoneType"))).Text;

            // BILLING ADDRESS (optional)  
            baddress.name = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("baddressName"))).Text;
            baddress.street1 = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("baddressStreet1"))).Text;
            baddress.street2 = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("baddressStreet2"))).Text;
            baddress.cityName = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("baddressCity"))).Text;
            baddress.zipCode = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("baddressZipCode"))).Text;
            baddress.country = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("baddressCountry"))).Text;
            baddress.phone = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("baddressPhone"))).Text;

            baddress.county = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("baddressCounty"))).Text;
            baddress.phoneType = ((DropDownList)(Page.PreviousPage.FindControl("updateWallet").FindControl("baddressPhoneType"))).Text;

            // BUYER (optional) 
            buyer.lastName = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("buyerLastName"))).Text;
            buyer.firstName = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("buyerFirstName"))).Text;
            buyer.email = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("buyerEmail"))).Text;

            buyer.shippingAdress = address;
            buyer.billingAddress = baddress;

            buyer.accountCreateDate = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("buyerAccountCreateDate"))).Text; // format : "dd/mm/yy"
            buyer.accountAverageAmount = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("buyerAccountAverageAmount"))).Text;
            buyer.accountOrderCount = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("buyerAccountOrderCount"))).Text;
            buyer.walletId = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("buyerWalletId"))).Text;

            //4.42
            string legalStatus = ((DropDownList)(Page.PreviousPage.FindControl("updateWallet").FindControl("buyerLegalStatus"))).Text;
            string legalDocument = ((DropDownList)(Page.PreviousPage.FindControl("updateWallet").FindControl("buyerLegalDocument"))).Text;

            buyer.legalStatus = (legalStatus == "--") ? "" : legalStatus;
            buyer.legalDocument = (legalDocument == "--") ? "" : legalDocument;

            buyer.birthDate = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("buyerBirthDate"))).Text;
            buyer.fingerprintID = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("buyerFingerprintID"))).Text;


            string walletDisplayed = ((DropDownList)(Page.PreviousPage.FindControl("updateWallet").FindControl("buyerWalletDisplayed"))).Text;

            buyer.walletDisplayed = (walletDisplayed == "--") ? "" : "none";

            string walletSecured = ((DropDownList)(Page.PreviousPage.FindControl("updateWallet").FindControl("buyerWalletSecured"))).Text;

            buyer.walletSecured = (walletSecured == "--") ? "" : "CVV";

            buyer.walletCardInd = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("buyerWalletCardInd"))).Text;
            buyer.ip = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("buyerIp"))).Text;
            buyer.mobilePhone = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("buyerMobilePhone"))).Text;
            buyer.customerId = ((TextBox)(Page.PreviousPage.FindControl("updateWallet").FindControl("buyerCustomerId"))).Text;


            //PROXY
            if (Resources.Resource.PROXY_HOST != "" && Resources.Resource.PROXY_PORT != "")
            {
                ws.Proxy = new System.Net.WebProxy(Resources.Resource.PROXY_HOST, Convert.ToInt32(Resources.Resource.PROXY_PORT));
                if (Resources.Resource.PROXY_USER != "" && Resources.Resource.PROXY_PASSWORD != "")
                {
                    ws.Proxy.Credentials = new System.Net.NetworkCredential(Resources.Resource.PROXY_USER, Resources.Resource.PROXY_PASSWORD);
                }
            }

            if (Resources.Resource.PROD == "true")
            {
                ws.Url = Resources.Resource.ENDPOINT_DIRECT;
            }
            else if (Resources.Resource.PROD == "dev")
            {
                ws.Url = Resources.Resource.ENDPOINT_DEV_DIRECT;
                System.Net.ServicePointManager.CertificatePolicy = new TrustAllCertificatePolicy();
            }

            ws.Credentials = new System.Net.NetworkCredential(Resources.Resource.MERCHANT_ID, Resources.Resource.ACCESS_KEY);

            resultat = ws.updateWallet(version, contractNumber, cardIndex, wallet, buyer, owner, privateDataList, authentication3DSecure, 
                                        media, ref contractNumberWalletList,
                                        out cardOut, out extendedCard);            
        }
        catch (Exception exc)
        {
            errorMessage = exc.Message;
            errorDetails = exc.ToString();
        }
    }
}
