﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class _Default : System.Web.UI.Page 
{
    public result resultat;
    public string token;
    public string redirectURL;
    public bool debug;
    public payment payment = new payment();
    public order order = new order();
    public buyer buyer = new buyer();
    public recurring recurring = new recurring();
    public address address = new address();
    public address baddress = new address();
    public orderDetail orderDetail1 = new orderDetail();
    public orderDetail orderDetail2 = new orderDetail();
    public privateData privateData1 = new privateData();
    public privateData privateData2 = new privateData();
    public privateData privateData3 = new privateData();
    public privateData[] privateDataList = new privateData[3];
    public string[] selectedCrontractList = new string[100];
    public string[] secondSelectedContractList = new string[100];
    public string contractNumberList;
    public string secondContractNumberList;
    public string errorMessage = "";
    public string errorDetails = "";
    public owner owner = new owner();
    public addressOwner addressOwner = new addressOwner();

    public string[] contractNumberWalletList = new string[10];
    public string version;

    public string stepCode;
    public string reqCode;
    public string method;

    
    protected void Page_Load(object sender, EventArgs e)
    {
        try
        {
            WebPaymentAPI ws = new WebPaymentAPI();

            // WSDL VERSION
            version = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("version"))).Text;
           
            // PAYMENT
            payment.amount = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("paymentAmount"))).Text;
            payment.mode = ((DropDownList)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("paymentMode"))).Text;
            payment.action = ((DropDownList)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("paymentFonction"))).Text;
            
            
            payment.currency = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("paymentCurrency"))).Text;
            if (payment.currency == "")
                payment.currency = Resources.Resource.PAYMENT_CURRENCY;

            payment.contractNumber = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("paymentContractNumber"))).Text;
            contractNumberList = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("paymentContractNumberList"))).Text;

            

            if (contractNumberList == "")
            {
                contractNumberList = Resources.Resource.CONTRACT_NUMBER_LIST;
            }


            if (contractNumberList.Contains(";"))
            {
                string[] split = contractNumberList.Split(new Char[] { ';' });
                selectedCrontractList = split;
            }
            else
            {
                selectedCrontractList.SetValue(contractNumberList, 0);
            }

            secondContractNumberList = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("paymentSecondContractNumberList"))).Text;

            if (secondContractNumberList == "")
            {
                secondContractNumberList = Resources.Resource.SECOND_CONTRACT_NUMBER_LIST;
            }


            if (secondContractNumberList.Contains(";"))
            {
                string[] split = secondContractNumberList.Split(new Char[] { ';' });
                secondSelectedContractList = split;
            }
            else
            {
                secondSelectedContractList.SetValue(secondContractNumberList, 0);
            }


            string contractNumberWalletList_str = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("contractNumberWalletList"))).Text;

            if (contractNumberWalletList_str.Contains(";"))
            {
                string[] split = contractNumberWalletList_str.Split(new Char[] { ';' });
                contractNumberWalletList = split;
            }
            else if (contractNumberWalletList_str.Length > 0)
            {
                contractNumberWalletList.SetValue(contractNumberWalletList_str, 0);
            }
            else 
            { 
                contractNumberWalletList = null; 
            }

            payment.differedActionDate = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("paymentDifferedActionDate"))).Text; // Format : "dd/mm/yy"

            // ORDER
            order.@ref = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("orderRef"))).Text;
            order.origin = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("orderOrigin"))).Text;
            order.country = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("orderCountry"))).Text;
            order.taxes = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("orderTaxes"))).Text;
            
            

            order.currency = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("orderCurrency"))).Text;
            if (order.currency == "")
                order.currency = Resources.Resource.ORDER_CURRENCY;
            
            order.amount = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("orderAmount"))).Text;
            order.date = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("orderDate"))).Text; // format : "dd/mm/yyyy HH24:MM"
            
            // ORDER DETAILS
            orderDetail1.@ref = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("orderDetailRef1"))).Text;
            orderDetail1.price = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("orderDetailPrice1"))).Text;
            orderDetail1.quantity = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("orderDetailQuantity1"))).Text;
            orderDetail1.comment = ((HtmlTextArea)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("orderDetailComment1"))).Value;

            orderDetail1.category = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("orderDetailCategory1"))).Text;
            orderDetail1.brand = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("orderDetailBrand1"))).Text;
            orderDetail1.subcategory1 = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("orderDetailSubcategory11"))).Text;
            orderDetail1.subcategory2 = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("orderDetailSubcategory21"))).Text;
            orderDetail1.additionalData = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("orderDetailAdditionalData1"))).Text;
            orderDetail1.taxRate = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("orderDetailTaxRate1"))).Text;

            orderDetail2.@ref = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("orderDetailRef2"))).Text;
            orderDetail2.price = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("orderDetailPrice2"))).Text;
            orderDetail2.quantity = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("orderDetailQuantity2"))).Text;
            orderDetail2.comment = ((HtmlTextArea)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("orderDetailComment2"))).Value;

            orderDetail2.category = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("orderDetailCategory2"))).Text;
            orderDetail2.brand = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("orderDetailBrand2"))).Text;
            orderDetail2.subcategory1 = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("orderDetailSubcategory12"))).Text;
            orderDetail2.subcategory2 = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("orderDetailSubcategory22"))).Text;
            orderDetail2.additionalData = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("orderDetailAdditionalData2"))).Text;
            orderDetail2.taxRate = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("orderDetailTaxRate2"))).Text;

            if (orderDetail1.@ref.Length > 0 && orderDetail2.@ref.Length > 0)
            {
                order.details = new orderDetail[2];
                order.details.SetValue(orderDetail1,0);
                order.details.SetValue(orderDetail2,1);
            }
            else if (orderDetail1.@ref.Length > 0 && orderDetail2.@ref.Length == 0)
            {
                order.details = new orderDetail[1];
                order.details.SetValue(orderDetail1, 0);
            }
            else if (orderDetail2.@ref.Length > 0 && orderDetail1.@ref.Length == 0)
            {
                order.details = new orderDetail[1];
                order.details.SetValue(orderDetail2, 0);
            }

            string deliveryMode = ((DropDownList)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("deliveryTime"))).Text;
            string deliveryTime = ((DropDownList)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("deliveryMode"))).Text;

            order.deliveryMode = (deliveryMode == "none") ? "" : deliveryMode;
            order.deliveryTime = (deliveryTime == "none") ? "" : deliveryTime;

            order.deliveryExpectedDate = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("deliveryExpectedDate"))).Text;
            order.deliveryExpectedDelay = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("deliveryExpectedDelay"))).Text;



            // SHIPPING ADDRESS (optional)            
            address.name = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("addressName"))).Text;
            address.street1 = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("addressStreet1"))).Text;
            address.street2 = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("addressStreet2"))).Text;
            address.cityName = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("addressCity"))).Text;
            address.zipCode = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("addressZipCode"))).Text;
            address.country = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("addressCountry"))).Text;
            address.phone = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("addressPhone"))).Text;

            address.county = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("addressCounty"))).Text;
            address.phoneType = ((DropDownList)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("addressPhoneType"))).Text;

            // BILLING ADDRESS (optional)  
            baddress.name = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("baddressName"))).Text;
            baddress.street1 = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("baddressStreet1"))).Text;
            baddress.street2 = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("baddressStreet2"))).Text;
            baddress.cityName = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("baddressCity"))).Text;
            baddress.zipCode = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("baddressZipCode"))).Text;
            baddress.country = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("baddressCountry"))).Text;
            baddress.phone = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("baddressPhone"))).Text;

            baddress.county = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("baddressCounty"))).Text;
            baddress.phoneType = ((DropDownList)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("baddressPhoneType"))).Text;
            
            // BUYER (optional) 
            buyer.lastName = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("buyerLastName"))).Text;
            buyer.firstName = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("buyerFirstName"))).Text;
            buyer.email = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("buyerEmail"))).Text;
            
            buyer.shippingAdress = address;
            buyer.billingAddress = baddress;

            buyer.accountCreateDate = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("buyerAccountCreateDate"))).Text; // format : "dd/mm/yy"
            buyer.accountAverageAmount = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("buyerAccountAverageAmount"))).Text;
            buyer.accountOrderCount = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("buyerAccountOrderCount"))).Text;
            buyer.walletId = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("buyerWalletId"))).Text;

            //4.42
            string legalStatus = ((DropDownList)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("buyerLegalStatus"))).Text;
            string legalDocument = ((DropDownList)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("buyerLegalDocument"))).Text;

            buyer.legalStatus = (legalStatus == "--") ? "" : legalStatus;
            buyer.legalDocument = (legalDocument == "--") ? "" : legalDocument;

            buyer.birthDate = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("buyerBirthDate"))).Text;
            buyer.fingerprintID = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("buyerFingerprintID"))).Text;


            string walletDisplayed = ((DropDownList)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("buyerWalletDisplayed"))).Text;

            buyer.walletDisplayed = (walletDisplayed == "--") ? "" : "none";

            string walletSecured = ((DropDownList)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("buyerWalletSecured"))).Text;

            buyer.walletSecured = (walletSecured == "--") ? "" : "CVV";

            buyer.walletCardInd = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("buyerWalletCardInd"))).Text;
            buyer.ip = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("buyerIp"))).Text;
            buyer.mobilePhone = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("buyerMobilePhone"))).Text;
            buyer.customerId = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("buyerCustomerId"))).Text;

                
            // PRIVATE DATA (optional)            
            privateData1.key = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("privateDataKey1"))).Text;
            privateData1.value = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("privateDataValue1"))).Text;
            privateData2.key = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("privateDataKey2"))).Text;
            privateData2.value = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("privateDataValue2"))).Text;
            privateData3.key = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("privateDataKey3"))).Text;
            privateData3.value = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("privateDataValue3"))).Text;
            
            privateDataList.SetValue(privateData1,0);
            privateDataList.SetValue(privateData2,1);
            privateDataList.SetValue(privateData3,2);


            //owner
            //Only for AMEX


            owner.lastName = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("ownerLastName"))).Text;
            owner.firstName = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("ownerFirstName"))).Text;
            owner.issueCardDate = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("ownerIssueCardDate"))).Text;
            


            addressOwner.street = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("addressOwnerStreet"))).Text;
            addressOwner.cityName = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("addressOwnerCityName"))).Text;
            addressOwner.zipCode = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("addressOwnerZipCode"))).Text;
            addressOwner.country = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("addressOwnerCountry"))).Text;
            addressOwner.phone = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("addressOwnerPhone"))).Text;

            owner.billingAddress = addressOwner;


            // TRANSACTION OPTIONS            
            string notificationURL = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("notificationURL"))).Text;
            if (notificationURL == "")
                notificationURL = Resources.Resource.NOTIFICATION_URL;

            string returnURL = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("returnURL"))).Text;
            if (returnURL == "")
                returnURL = Resources.Resource.RETURN_URL;
            
            string cancelURL = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("cancelURL"))).Text;
            if (cancelURL == "")
                cancelURL = Resources.Resource.CANCEL_URL;
            
            string customPaymentPageCode = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("customPaymentPageCode"))).Text;
            if (customPaymentPageCode == "")
                customPaymentPageCode = Resources.Resource.CUSTOM_PAYMENT_PAGE_CODE;

            string customPaymentTemplateURL = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("customPaymentTemplateURL"))).Text;
            if (customPaymentTemplateURL == "")
                customPaymentTemplateURL = Resources.Resource.CUSTOM_PAYMENT_TEMPLATE_URL;
            
            string languageCode = ((DropDownList)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("languageCode"))).Text;
            if (languageCode == "")
                languageCode = Resources.Resource.LANGUAGE_CODE;

            // RECCURENT
            bool recurringCheck = ((CheckBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("recurring"))).Checked;
            if ((recurringCheck) || (payment.mode == "NX") || (payment.mode == "REC"))
            {
                recurring.firstAmount = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("recurringFirstAmount"))).Text;
                recurring.billingLeft = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("recurringBillingLeft"))).Text;
                recurring.amount = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("recurringAmount"))).Text;
                recurring.billingCycle = ((DropDownList)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("recurringBillingCycle"))).Text;
                recurring.startDate = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("recurringStartDate"))).Text; // format : "dd/mm/yyyy"
                recurring.billingDay = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("recurringBillingDay"))).Text; // Format : "dd"
                recurring.endDate = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("endDate"))).Text; // Format : "dd"
                recurring.newAmount = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("newAmount"))).Text;
                recurring.amountModificationDate = ((TextBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("amountModificationDate"))).Text; // format : "dd/mm/yyyy"
                
            }
            else
                recurring = null;

            

            //PROXY
            if (Resources.Resource.PROXY_HOST != "" && Resources.Resource.PROXY_PORT != "")
            {
                
                ws.Proxy = new System.Net.WebProxy(Resources.Resource.PROXY_HOST, Convert.ToInt32(Resources.Resource.PROXY_PORT));
                if (Resources.Resource.PROXY_USER != "" && Resources.Resource.PROXY_PASSWORD != "")
                {
                    
                    ws.Proxy.Credentials = new System.Net.NetworkCredential(Resources.Resource.PROXY_USER, Resources.Resource.PROXY_PASSWORD);
                }
            }

            if (Resources.Resource.PROD == "true")
            {
                ws.Url = Resources.Resource.ENDPOINT_WEB;
            }
            else if (Resources.Resource.PROD == "dev")
            {
                ws.Url = Resources.Resource.ENDPOINT_DEV_WEB;
                System.Net.ServicePointManager.CertificatePolicy = new TrustAllCertificatePolicy();
            }

            ws.Credentials = new System.Net.NetworkCredential(Resources.Resource.MERCHANT_ID, Resources.Resource.ACCESS_KEY);

            resultat = ws.doWebPayment(version, payment, returnURL, cancelURL, order, notificationURL, 
                                                selectedCrontractList, secondSelectedContractList, privateDataList, 
                                                languageCode, customPaymentPageCode, buyer, owner, 
                                                Resources.Resource.SECURITY_MODE, recurring, customPaymentTemplateURL, 
                                                contractNumberWalletList,
                                                out token, out redirectURL, out stepCode, out reqCode, out method);

            debug = ((CheckBox)(Page.PreviousPage.FindControl("fullWebPayment").FindControl("debug"))).Checked;
        }
        catch (Exception exc)
        {
            errorMessage = exc.Message;
            errorDetails = exc.ToString();
        }            
    }
}