﻿<%@ Control Language="C#" AutoEventWireup="false" CodeFile="doAuthorizationTokenForm.ascx.cs" Inherits="web_WebUserControl"%>

<html>
<head>

    <script type = "text/javascript">
        function hideButtons() {
            getAction();
            var environnement = "<%=Resources.Resource.PROD %>";
            document.getElementById('dev').style.display = "none";
            document.getElementById('homo').style.display = "none";
            document.getElementById('prod').style.display = "none";

            if (environnement == "false") {
                document.getElementById('homo').style.display = "block";
            } else if (environnement == "true") {
                document.getElementById('prod').style.display = "block";
            } else if (environnement == "dev") {
                document.getElementById('dev').style.display = "block";
            }
        }

    function transactionAfter() {
        var select = document.getElementById("makeTransaction");
                
        var returnURL = document.getElementById("returnURL");

        if (select.checked) {
            returnURL.value = returnURL.value.replace("?makeTransaction=false", "?makeTransaction=true");
        } else {
            returnURL.value = returnURL.value.replace("?makeTransaction=true", "?makeTransaction=false");
        }
    }
        
    function actionCode(code) {
        var returnURL = document.getElementById("returnURL");
        var actionCode = getAction();
        var motif = returnURL.value.substring(returnURL.value.indexOf("&"));
        returnURL.value = returnURL.value.replace(motif, "&action=" + code.value);
    }

    function getAction() {
        
        var actionCode = 110;
        var actionObject = document.getElementsByName("action");
        for (var i = 0; i < actionObject.length; i++) {
            if (actionObject[i].checked) {
                actionCode = actionObject[i].value;
            }
        }
        return actionCode;
    }


    </script>
    <title>web2Token</title>
</head>
<body onload="hideButtons()">
        
    <h2>Action after the tokenisation</h2>
    <input type="checkbox" id="makeTransaction" name="makeTransaction" onclick="transactionAfter()" />
    <label for="makeTransaction">Do a transaction after the tokenisation (doAuthorization)</label>
    <br />
                
    <input type="radio" id="id110" name="action" value="110" checked="checked" onclick="actionCode(this);" />
    <label for="id110">Action code is 110 - The token will be used again without CVV</label>
    <br />
                
    <input type="radio" id="id111" name="action" value="111" onclick="actionCode(this);"/>
    <label for="id111">Action code is 111 -  The token will be used again without CVV</label>
    <br />
                    
    <input type="radio" id="id100" name="action" value="100" onclick="actionCode(this);"/>
    <label for="id100">Action code is 100 - The token can be reused only if you collect the CVV again</label>
    <br />
                
    <input type="radio" id="id101" name="action" value="101"  onclick="actionCode(this);"/>
    <label for="id101">Action code is 101 - The token can be reused only if you collect the CVV again</label>
   
<form runat="server" id="FormWeb2Token" method="post" class="payline-form" >
    <fieldset>
    <h2>Information for the tokenization</h2>
        <div class="row">
            <label for="contractNumber">Contract number used</label>
            <input type="text" id="contractNumber" name="contractNumber" value="<%=Resources.Resource.WEB2TOKEN_CONTRACT_NUMBER%>" />
            <span class="help">(To use another payment like AMEX, change the WEB2TOKEN_CONTRACT_NUMBER in the file Resources.resx)</span>
        </div>
        <div class="row">
            <label for="accessKeyRef">Web2Token reference</label>
            <input type="text" id="accessKeyRef" name="accessKeyRef" value="<%=Resources.Resource.WEB2TOKENKEY%>" />
        </div>
        <div class="row">
            <label for="returnURL">ReturnUrl</label>
            <input type="text" id="returnURL" name="returnURL" value="<%=Resources.Resource.WEB2TOKEN_CALLBACK_URL%>" />
        </div>
    
        <div class="row">
            <label for="data">data</label>
            <input type="text" id="data" name="data" value="<%=SDKPayline.Utils.AESEncrypt(Resources.Resource.MERCHANT_ID + ";" + "w2t_" + DateTime.Now.ToString("yyyy-MM-dd H:mm:ss") + ";" + Resources.Resource.WEB2TOKEN_CONTRACT_NUMBER, SDKPayline.Utils.Hash256(Resources.Resource.ACCESS_KEY))%>" />
            <span class="help">(Data = encrypt(Merchant ID + ";" + order.ref + ";" contractNumber",Access key))</span>
        </div>

        <div class="row">
            <label for="cardNumber">Card number</label>
            <input type="text" id="cardNumber" name="cardNumber" value="4444333322221111" />
        </div>

        <div class="row">
            <label for="cardExpirationDate">Card expiration date</label>
            <input type="text" id="cardExpirationDate" name="cardExpirationDate" value="1015" />
        </div>

        <div class="row">
            <label for="cardCvx">Card cvx</label>
            <input type="text" id="cardCvx" name="cardCvx" value="123" />      
        </div>

    </fieldset>

    <asp:Button ID="dev" ClientIDMode="Static" Text="start payment process in dev" CssClass="submit" PostBackUrl="https://wp.dev.payline.aixlan.local:9366/webpayment/getToken" runat="server" />
    <asp:Button ID="homo" ClientIDMode="Static"  Text="start payment process in homo" CssClass="submit" PostBackUrl="https://homologation-webpayment.payline.com/webpayment/getToken" runat="server" />
    <asp:Button ID="prod" ClientIDMode="Static"  Text="start payment process in prod" CssClass="submit" PostBackUrl="https://webpayment.payline.com/webpayment/getToken" runat="server" />
</form>

</body>
</html>